<div class="container-fluid mt-0 mb-5 pl-0 pr-0">  
  <form #dataLayoutForm="ngForm">
    <ejs-grid #kpiListGrid [dataSource]="KPIRules 
    | filter:searchtxt:['data_layer_nm', 'obj_nm', 'rule_desc', 'cstm_qry']
    | arrayFilter:layerToFilter:['data_layer_id']:filterMetadata 
    | arrayFilter:objToFilter:['obj_id']:filterMetadata
    | arrayFilter:severityToFilter:['rule_svrt']:filterMetadata 
    | arrayFilter:statusToFilter:['is_rule_actv']:filterMetadata"
    (dataBound)="onKPIListGridDataBound()" [allowPaging]="true" [allowSorting]="true" [showColumnChooser]="true"
    [toolbar]="gridToolbar" [pageSettings]="gridPageSettings" [allowTextWrap]="true">
      <e-columns>
        <e-column type='checkbox' [allowFiltering]='false' [allowSorting]='false' width='60'></e-column>
        <e-column field="data_layer_nm" headerText={{kpi.ruleListColumn.objLayerNm}}>
          <ng-template #template let-KPIRules>
            <span title="{{KPIRules.data_layer_nm}}">
              {{KPIRules.data_layer_nm !== null && KPIRules.data_layer_nm?.length > 25 ? KPIRules.data_layer_nm.slice(0,25).concat("...") : KPIRules.data_layer_nm}}
            </span>
          </ng-template>
        </e-column>
        <e-column field="obj_nm" headerText={{kpi.ruleListColumn.objNm}} isPrimaryKey="true">
          <ng-template #template let-KPIRules>
            <span title="{{KPIRules.obj_nm}}">
              {{KPIRules.obj_nm !== null && KPIRules.obj_nm?.length > 25 ? KPIRules.obj_nm.slice(0,25).concat("...") : KPIRules.obj_nm}}
            </span>
          </ng-template>
        </e-column>
        <e-column field="cstm_qry" headerText="{{kpi.ruleListColumn.query}}">
          <ng-template #template let-KPIRules>
            <span title="{{KPIRules.cstm_qry}}">
              {{KPIRules.cstm_qry !== null && KPIRules.cstm_qry?.length > 25 ? KPIRules.cstm_qry.slice(0,25).concat("...") : KPIRules.cstm_qry}}
            </span>
          </ng-template>
        </e-column>
        <e-column field="rule_desc" headerText="{{kpi.ruleListColumn.ruleDescription}}">
          <ng-template #template let-KPIRules>
            <span title="{{KPIRules.rule_desc}}">
              {{KPIRules.rule_desc !== null && KPIRules.rule_desc?.length > 25 ? KPIRules.rule_desc.slice(0,25).concat("...") : KPIRules.rule_desc}}
            </span>
          </ng-template>
        </e-column>
        <e-column field="actv_disp" headerText="{{kpi.ruleListColumn.status}}" width='100' class="justify-content-center">
          <ng-template #template let-KPIRules>
            <div class="switch">
              {{KPIRules.is_rule_actv?'Yes':''}}
              <ejs-switch [checked]="KPIRules.is_rule_actv" [disabled]="true"></ejs-switch>
              {{KPIRules.is_rule_actv?'':'No'}}
            </div>
          </ng-template>
        </e-column>
        <e-column field="rule_svrt" headerText="{{kpi.ruleListColumn.severity}}" width='130'>
          <ng-template #template let-KPIRules>
            <span title="{{KPIRules.rule_svrt}}">
              {{KPIRules.rule_svrt !== null && KPIRules.rule_svrt?.length > 25 ? KPIRules.rule_svrt.slice(0,25).concat("...") : KPIRules.rule_svrt}}
            </span>
          </ng-template>
        </e-column>
        <e-column headerText="{{kpi.ruleListColumn.editCommands}}" [commands]="gridCommands" width='85'
        textAlign="Center">
        </e-column>
      </e-columns>
    </ejs-grid>
  </form>
  <span class="d-flex float-right top-minus-42" id="customPagerTemplate">
    <span class="text-dark ml-5 mr-2 mt-2 pt-1">Results Per Page</span>
    <span class="mt-1">
      <ejs-dropdownlist name="pageSize" cssClass="e-outline" [dataSource]="['All', '5', '10', '20', '30', '50', '100']"
        value="5" (change)="changePageSize($event)" width="75px">
      </ejs-dropdownlist>
    </span>
  </span>
  </div>
  <span *ngIf="active">
    <span id="showKPIResultsCount" class="top-minus-5">
      <span class="text-muted">{{(kpiListGrid.pageSettings.currentPage-1)*kpiListGrid.pageSettings.pageSize+1}}
        - {{filterMetadata.count > kpiListGrid.pageSettings.currentPage*kpiListGrid.pageSettings.pageSize ? kpiListGrid.pageSettings.currentPage*kpiListGrid.pageSettings.pageSize : filterMetadata.count}}</span>
    </span>
    <span id="addKPIRuleTemplate" class="mr-0 top-minus-5">
      <button class="iconTextButton btn btn-primary" data-ripple="true"
        aria-label="Add New KPI Rule">
        <img src="assets/images/novartis/add.svg" alt="Add New Rule"/>{{dataQualityContent.addNewRule}}</button>
    </span>
    <span id="exportKPITemplate" class="mr-1 top-minus-5">
      <button class="iconButton btn btn-primary" data-ripple="true"
        aria-label="Export KPI Rules">
        <img src="assets/images/novartis/upload.svg" alt="Import Rules"/>
      </button>
    </span>
    <span id="columnChooserTemplateKPI" class=" mr-0 top-minus-8">
      <button class="iconButton btn btn-primary" data-ripple="true"
        aria-label="Choose Columns To be Displayed">
        <img src="assets/images/novartis/column.svg" alt="Choose Columns"/>
      </button>
    </span>
  </span>
  <ejs-dialog #addNewKPIRuleDialog
    [header]="isRuleEditMode?kpi.dialogForm.editRuleHeader:kpi.dialogForm.addRuleHeader"
    [buttons]="dlgButtons" [visible]="false" [isModal]="true" [position]="position" showCloseIcon="true"
    [animationSettings]="dlgAnimationSettings" (close)="modalDlgClose()">
    <ng-template #content>
      <app-kpi-validation-form #kpiValidationFormComponent
        (latestRuleIdEmitter)="updateLatestRuleId($event)">
      </app-kpi-validation-form>
    </ng-template>
  </ejs-dialog>